// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'XLSMapParser.pas' rev: 6.00

#ifndef XLSMapParserHPP
#define XLSMapParserHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <XLSFile.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Xlsmapparser
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TRangeType { rtCol, rtRow, rtCell, rtUnknown };
#pragma option pop

#pragma option push -b-
enum TRangeDirection { rdDown, rdUp, rdUnknown };
#pragma option pop

#pragma option push -b-
enum TSheetIDType { sitUnknown, sitName, sitNumber };
#pragma option pop

class DELPHICLASS TMapRange;
class DELPHICLASS TMapRow;
class DELPHICLASS TMapRowList;
class PASCALIMPLEMENTATION TMapRowList : public Classes::TList 
{
	typedef Classes::TList inherited;
	
public:
	TMapRow* operator[](int Index) { return Items[Index]; }
	
private:
	Xlsfile::TxlsFile* FXLSFile;
	int FMaxRow;
	int FMinRow;
	int FSkipFirstCols;
	int FSkipFirstRows;
	TMapRow* __fastcall GetItems(int Index);
	void __fastcall SetItems(int Index, TMapRow* Value);
	
public:
	__fastcall TMapRowList(Xlsfile::TxlsFile* XLSFile);
	HIDESBASE int __fastcall Add(TMapRow* Item);
	HIDESBASE void __fastcall Delete(int Index);
	void __fastcall Update(void);
	__property Xlsfile::TxlsFile* XLSFile = {read=FXLSFile};
	__property TMapRow* Items[int Index] = {read=GetItems, write=SetItems/*, default*/};
	__property int MaxRow = {read=FMaxRow, nodefault};
	__property int MinRow = {read=FMinRow, nodefault};
	__property int SkipFirstRows = {read=FSkipFirstRows, write=FSkipFirstRows, nodefault};
	__property int SkipFirstCols = {read=FSkipFirstCols, write=FSkipFirstCols, nodefault};
public:
	#pragma option push -w-inl
	/* TList.Destroy */ inline __fastcall virtual ~TMapRowList(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TMapRow : public Classes::TList 
{
	typedef Classes::TList inherited;
	
public:
	TMapRange* operator[](int Index) { return Items[Index]; }
	
private:
	TMapRowList* FMapRowList;
	Xlsfile::TxlsFile* FXLSFile;
	int FLength;
	TMapRange* __fastcall GetItems(int Index);
	void __fastcall SetItems(int Index, TMapRange* Value);
	AnsiString __fastcall GetAsString();
	void __fastcall SetAsString(const AnsiString Value);
	int __fastcall GetSkipFirstRows(void);
	int __fastcall GetSkipFirstCols(void);
	
public:
	__fastcall TMapRow(TMapRowList* MapRowList);
	HIDESBASE int __fastcall Add(TMapRange* Item);
	HIDESBASE void __fastcall Delete(int Index);
	void __fastcall Update(void);
	AnsiString __fastcall GetCellValue(int AbsoluteIndex);
	void __fastcall Optimize(void);
	int __fastcall IndexOfRange(const AnsiString RangeStr);
	__property TMapRowList* MapRowList = {read=FMapRowList};
	__property Xlsfile::TxlsFile* XLSFile = {read=FXLSFile};
	__property TMapRange* Items[int Index] = {read=GetItems, write=SetItems/*, default*/};
	__property int Length = {read=FLength, nodefault};
	__property AnsiString AsString = {read=GetAsString, write=SetAsString};
	__property int SkipFirstRows = {read=GetSkipFirstRows, nodefault};
	__property int SkipFirstCols = {read=GetSkipFirstCols, nodefault};
public:
	#pragma option push -w-inl
	/* TList.Destroy */ inline __fastcall virtual ~TMapRow(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TMapRange : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TMapRow* FMapRow;
	Xlsfile::TxlsFile* FXLSFile;
	TRangeDirection FDirection;
	TSheetIDType FSheetIDType;
	int FSheetNumber;
	WideString FSheetName;
	int FRow1;
	int FCol1;
	int FRow2;
	int FCol2;
	TRangeType FRangeType;
	int FLength;
	void __fastcall Arrange(void);
	bool __fastcall GetHasSheet(void);
	AnsiString __fastcall GetAsString();
	int __fastcall GetSkipFirstRows(void);
	int __fastcall GetSkipFirstCols(void);
	
protected:
	void __fastcall UpdateDirection(void);
	
public:
	__fastcall TMapRange(TMapRow* MapRow);
	void __fastcall Update(void);
	void __fastcall Assign(TMapRange* Range);
	__property TMapRow* MapRow = {read=FMapRow, write=FMapRow};
	__property Xlsfile::TxlsFile* XLSFile = {read=FXLSFile};
	__property TRangeType RangeType = {read=FRangeType, nodefault};
	__property TRangeDirection Direction = {read=FDirection, write=FDirection, nodefault};
	__property bool HasSheet = {read=GetHasSheet, nodefault};
	__property TSheetIDType SheetIDType = {read=FSheetIDType, write=FSheetIDType, nodefault};
	__property int SheetNumber = {read=FSheetNumber, write=FSheetNumber, nodefault};
	__property WideString SheetName = {read=FSheetName, write=FSheetName};
	__property int Row1 = {read=FRow1, write=FRow1, nodefault};
	__property int Col1 = {read=FCol1, write=FCol1, nodefault};
	__property int Row2 = {read=FRow2, write=FRow2, nodefault};
	__property int Col2 = {read=FCol2, write=FCol2, nodefault};
	__property int Length = {read=FLength, nodefault};
	__property AnsiString AsString = {read=GetAsString};
	__property int SkipFirstRows = {read=GetSkipFirstRows, nodefault};
	__property int SkipFirstCols = {read=GetSkipFirstCols, nodefault};
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TMapRange(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TCellNeighbour { cnLeft, cnRight, cnTop, cnBottom };
#pragma option pop

typedef Set<TCellNeighbour, cnLeft, cnBottom>  TCellNeighbours;

//-- var, const, procedure ---------------------------------------------------
static const Word MAX_COL = 0x100;
static const int MAX_ROW = 0x10000;
static const char RANGE_DELIMITER = '\x3b';
static const char ARRAY_DELIMITER = '\x2d';
static const char SHEET_START = '\x5b';
static const char SHEET_FINISH = '\x5d';
static const char SHEET_NUMBER = '\x3a';
#define ILLEGAL_IN_SHEET ":\\/?*[]"
#define COLSTART "COLSTART"
#define COLFINISH "COLFINISH"
#define ROWSTART "ROWSTART"
#define ROWFINISH "ROWFINISH"
extern PACKAGE bool __fastcall ParseMapString(const AnsiString MapString, TMapRow* MapRow);
extern PACKAGE void __fastcall ParseCellString(const AnsiString CellString, int &Col, int &Row);
extern PACKAGE void __fastcall ParseColString(const AnsiString ColString, int &Col);
extern PACKAGE void __fastcall ParseRowString(const AnsiString RowString, int &Row);
extern PACKAGE void __fastcall ParseSheetNumber(const AnsiString SheetNumber, int &Sheet);
extern PACKAGE void __fastcall ParseSheetName(const AnsiString SheetName, AnsiString &Sheet);
extern PACKAGE bool __fastcall CellInRange(TMapRange* Range, const AnsiString SheetName, int SheetNumber, int Col, int Row);
extern PACKAGE bool __fastcall CellInRow(TMapRow* MapRow, const AnsiString SheetName, int SheetNumber, int Col, int Row);
extern PACKAGE TCellNeighbours __fastcall GetCellNeighbours(TMapRow* MapRow, const AnsiString SheetName, int SheetNumber, int Col, int Row);
extern PACKAGE void __fastcall RemoveCellFromRow(TMapRow* MapRow, const AnsiString SheetName, int SheetNumber, int Col, int Row);
extern PACKAGE void __fastcall Str2ColRow(const AnsiString Str, int &ACol, int &ARow);
extern PACKAGE void __fastcall Str2Range(const AnsiString Str, int &ACol1, int &ARow1, int &ACol2, int &ARow2);
extern PACKAGE TRangeType __fastcall GetRangeType(const AnsiString Str);
extern PACKAGE AnsiString __fastcall OptimizeString(const AnsiString Str);
extern PACKAGE AnsiString __fastcall SkipFirstRows(const AnsiString Str, int Rows);
extern PACKAGE AnsiString __fastcall SkipFirstCols(const AnsiString Str, int Cols);
extern PACKAGE AnsiString __fastcall CheckRange(const AnsiString Str);

}	/* namespace Xlsmapparser */
using namespace Xlsmapparser;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// XLSMapParser
